net.sf.saxon.expr

## Class GeneralComparison20

- java.lang.Object
- - net.sf.saxon.expr.Expression
  - - net.sf.saxon.expr.BinaryExpression
    - - net.sf.saxon.expr.GeneralComparison
      - - net.sf.saxon.expr.GeneralComparison20

- All Implemented Interfaces:
    Serializable, SourceLocator, LocationProvider, SaxonLocator, Callable, ComparisonExpression, InstructionInfo, Locator

      public class GeneralComparison20
      extends GeneralComparison

  The class GeneralComparison20 specializes GeneralComparison for the case where the comparison is done with 2.0 semantics (i.e. with backwards compatibility off). It differs from the superclass in that it will never turn the expression into a GeneralComparison10, which could lead to non-terminating optimizations
  See Also:
    Serialized Form

- - ### Field Summary

    - ### Fields inherited from class net.sf.saxon.expr.GeneralComparison

      `comparer, comparisonCardinality, MANY_TO_MANY, MANY_TO_ONE, needsRuntimeCheck, ONE_TO_ONE, singletonOperator`

    - ### Fields inherited from class net.sf.saxon.expr.BinaryExpression

      `operand0, operand1, operator`

    - ### Fields inherited from class net.sf.saxon.expr.Expression

      `EFFECTIVE_BOOLEAN_VALUE, EVALUATE_METHOD, EVENT_FEED_METHOD, INHERITED_CONTEXT, INSPECTION_CONTEXT, ITEM_FEED_METHOD, ITERATE_METHOD, locationId, MAX_SEQUENCE_LENGTH, MAX_STRING_LENGTH, NAVIGATION_CONTEXT, NODE_VALUE_CONTEXT, PROCESS_METHOD, PUSH_SELECTION, staticProperties, UNBOUNDED_LOWER, UNBOUNDED_UPPER, W3C_CONSUMING, W3C_FREE_RANGING, W3C_GROUP_CONSUMING, W3C_MOTIONLESS, WATCH_METHOD`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `GeneralComparison20(Expression p0, int op, Expression p1)` Create a relational expression identifying the two operands and the operator

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `Expression` | `copy()` Copy an expression.
    `ExpressionCompiler` | `getExpressionCompiler()` Return the compiler of the GeneralComparison20 expression
    `protected GeneralComparison` | `getInverseComparison()`

    - ### Methods inherited from class net.sf.saxon.expr.GeneralComparison

      `call, compare, computeCardinality, convertsUntypedToOther, effectiveBooleanValue, evaluateItem, evaluateManyToMany, explainExtraAttributes, getAtomicComparer, getComparisonCardinality, getCorrespondingSingletonOperator, getExpressionName, getItemType, getSingletonOperator, getStreamingAdjunct, needsRuntimeCheck, optimize, setAtomicComparer, setComparisonCardinality, setNeedsRuntimeCheck, simplify, typeCheck`

    - ### Methods inherited from class net.sf.saxon.expr.BinaryExpression

      `computeSpecialProperties, displayOperator, equals, explain, getArguments, getOperands, getOperator, hashCode, isAssociative, isCommutative, isInverse, iterateSubExpressionInfo, iterateSubExpressions, promote, replaceSubExpression, setFlattened, toString`

    - ### Methods inherited from class net.sf.saxon.expr.Expression

      `addToPathMap, adoptChildExpression, checkForUpdatingSubexpressions, checkPermittedContents, computeDependencies, computeStaticProperties, doPromotion, dynamicError, evaluateAsString, evaluatePendingUpdates, explain, getCardinality, getColumnNumber, getColumnNumber, getConstructType, getContainer, getDependencies, getEvaluationMethod, getExecutable, getHostLanguage, getImplementationMethod, getIntegerBounds, getIntrinsicDependencies, getLineNumber, getLineNumber, getLocationId, getLocationProvider, getObjectName, getProperties, getProperty, getPublicId, getSlotsUsed, getSpecialProperties, getStreamability, getSystemId, getSystemId, hasVariableBinding, implementsStaticTypeCheck, isSubtreeExpression, isUpdatingExpression, isVacuousExpression, iterate, iterateEvents, markTailFunctionCalls, process, resetLocalStaticProperties, setContainer, setEvaluationMethod, setFiltered, setLocationId, staticTypeCheck, suppressValidation, toPattern, toStreamingPattern, typeError`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.expr.ComparisonExpression

      `getOperands`

- - ### Constructor Detail

    - #### GeneralComparison20

          public GeneralComparison20(Expression p0,
                             int op,
                             Expression p1)

      Create a relational expression identifying the two operands and the operator
      Parameters:
        `p0` - the left-hand operand
        `op` - the operator, as a token returned by the Tokenizer (e.g. Token.LT)
        `p1` - the right-hand operand

  - ### Method Detail

    - #### copy

          public Expression copy()

      Copy an expression. This makes a deep copy.
      Overrides:
        `copy` in class `GeneralComparison`
      Returns:
        the copy of the original expression

    - #### getInverseComparison

          protected GeneralComparison getInverseComparison()

      Overrides:
        `getInverseComparison` in class `GeneralComparison`

    - #### getExpressionCompiler

          public ExpressionCompiler getExpressionCompiler()

      Return the compiler of the GeneralComparison20 expression
      Overrides:
        `getExpressionCompiler` in class `GeneralComparison`
      Returns:
        the relevant ExpressionCompiler

Copyright (c) 2004-2013 Saxonica Limited. All rights reserved.